from kali.controller import Pseudo, PseudoAvatar


class Anonymous(PseudoAvatar):
    def cmd_help(self, pseudo, *params):
        self.notice('AresServ provides various extended network services.')
        self.notice(' ')
        self.notice('No commands are currently available to you.')

    def cmd_raw(self, pseudo, *params):
        """
        RAW command to inject a message directly onto IRC.

        XXX: This is for debugging purposes only, and should be removed somehow
             once we go to production; maybe a global flag somewhere?
        """
        self.pseudo.protocol.sendLine(' '.join(params))


class AresServ(Pseudo):
    nick = 'AresServ'
    name = 'Ares Network Services'
    anonymousAvatarFactory = Anonymous

    def getAvatar(self, nick):
        return None

    def login(self, nick):
        avatar = self.getAvatar(nick)
        if avatar is not None:
            self.avatars[nick] = avatar

    def logout(self, nick):
        self.avatars.pop(nick, None)

    def event_newuser(self, user):
        if user.hasMode('r'):
            self.login(user.nick)

    def event_nickchange(self, old, new):
        self.logout(old)
        if self.ctrl.getUser(new).hasMode('r'):
            self.login(new)

    def event_quit(self, nick, msg):
        self.logout(nick)
